use super::schema::{klassen, vertretungen};
use std::cmp::Eq;

#[derive(Queryable, Debug, Serialize, Hash, PartialEq, Clone)]
pub struct Stunde {
    pub stunden_id: i32,
    pub title: String,
    pub short: String,
    pub ordinal: i32,
}

impl Eq for Stunde {}

#[derive(Identifiable, Queryable, Debug, Serialize, Associations)]
#[belongs_to(Klasse)]
#[belongs_to(Stunde)]
#[table_name = "vertretungen"]
pub struct Vertretung {
    pub id: i32,
    pub klasse_id: i32,
    pub stunde_id: i32,
    pub fehlend: String,
    pub vertretung: String,
    pub kommentar: String,
}

#[derive(Identifiable, Queryable, Debug, Serialize, Associations)]
#[table_name = "klassen"]
#[primary_key(klassen_id)]
pub struct Klasse {
    pub klassen_id: i32,
    pub stufe: i32,
    pub gruppe: String,
    pub titel: Option<String>,
    pub ordnung: i32,
}

#[derive(Serialize, Insertable)]
#[table_name = "klassen"]
pub struct NewKlasse {
    pub stufe: i32,
    pub gruppe: String,
    pub titel: Option<String>,
    pub ordnung: i32,
}
